#include <ntddk.h>
#include "..\\ioctl.h"

//
#define MAX_PID_TABLE 20							//PIDĿ

//Ӳ
#define INDEX_OF_NTCREATETHREAD				0x35	//NtCreateProcessSSDTеƫ
#define OFFSET_PERENT_PID_EPROCESS			0x14c	//PIDEPROCESSеƫ
#define OFFSET_THREAD_LIST_HEAD_EPROCESS	0x190	//ThreadListHeadEPROCESSеƫ
#define OFFSET_START_ADDRESS_ETHREAD		0x224	//StartAddressETHREADеƫ




//ԭ
NTKERNELAPI
NTSTATUS
  PsLookupProcessByProcessId(
				 IN HANDLE ProcessId,
				 OUT PEPROCESS *Process
    );


NTKERNELAPI
VOID
KeAttachProcess (
				 PEPROCESS Process
				 );

NTKERNELAPI
VOID
KeDetachProcess (
				 VOID
				 );

NTKERNELAPI
NTSTATUS
NTAPI
ZwTerminateProcess (
				 IN HANDLE   ProcessHandle OPTIONAL,
				 IN NTSTATUS ExitStatus
); 





//ݽṹ,.
#pragma pack(1)
typedef struct ServiceDescriptorEntry {
	unsigned int *ServiceTableBase;
	unsigned int *ServiceCounterTableBase; //checked build汾
	unsigned int NumberOfServices;
	unsigned char *ParamTableBase;
} ServiceDescriptorTableEntry_t, *PServiceDescriptorTableEntry_t;
#pragma pack()


__declspec(dllimport) ServiceDescriptorTableEntry_t KeServiceDescriptorTable;





//

PVOID FindPspUserThreadStartupAddress();		//ȡPspUserThreadStartupĵַ

ULONG IsPidInTable(IN ULONG Pid);				//жPIDǷڱ

ULONG SetPidTable(IN ULONG Pid,					//PIDӻɾPID
				  IN ULONG bAdd);		

void FakePspUserThreadStartup();				//Լðĺ
void DoSomethingIWant(PULONG arg);				//FakePspUserThreadStartupCALL,inline hookԼĶ:)

ULONG GetProcessPathNameByPID(IN ULONG Pid, 
							  OUT PANSI_STRING pas);		//ͨPIDýȫ·,ɹҪRtlFreeAnsiString

void GetProcessPathName(IN ULONG dwEPROCESS,				//ͨEPROCESSýȫ·,ɹҪRtlFreeAnsiString
						 OUT PANSI_STRING pas) ;

ULONG GetUserChoose(IN PANSI_STRING pAnsiPerent ,			//Ӧò㽻,ϢݸӦò㲢ûѡ
					IN PANSI_STRING pAnsiCurrent,
					IN  ULONG PerentId,
					IN  ULONG CurrentPId);

void HookPspUserThreadStartup();							//ҹ
void UnhookPspUserThreadStartup();							//ȡҹ

NTSTATUS DispatchCreate(PDEVICE_OBJECT pDevObj, PIRP pIrp);	//ַ
NTSTATUS DispatchClose(PDEVICE_OBJECT pDevObj, PIRP pIrp);
NTSTATUS DispatchIoctl(PDEVICE_OBJECT pDevObj, PIRP pIrp);
void OnUnload(PDRIVER_OBJECT pdo);							//жغ








//ȫֱ

ULONG g_i = 0;						//ָʾǰжٽ̵ȴûѡ
PVOID g_Orig;						//Լĺתԭ ,ͬʱ֮ǰHOOKʱ޸ĵ
KEVENT g_eventNotify;				//4¼
KEVENT g_event;
PKEVENT g_pEventWaitInDriver;
PKEVENT g_pEventWaitInApp;
PUCHAR g_MsgBuffer;					//Ӧò㹲ڴ
ULONG g_PidTable[MAX_PID_TABLE];	//20
ULONG g_uStartSign;					//ǵһ̵߳ûʼַ





//ʵ



/************************************************************************/
/*    ȡPspUserThreadStartupĵַ                                  */
/************************************************************************/
PVOID FindPspUserThreadStartupAddress()
{

	ULONG AddrNtCreateThread = 0;
	ULONG AddrPspCreateThread = 0;
	ULONG AddrPspUserThreadStartup = 0;
	ULONG i;
	UCHAR code1[29] = "\x52\x52\xff\x75\x24\x8d\x45\xc8\x50\xff\x75\x1c\xff\x75\x18\x52\xff\x75\x14\xff\x75\x10\xff\x75\x0c\xff\x75\x08\xe8";
	UCHAR code2[15] = "\xff\x75\xe4\xff\x75\x20\xff\xb6\x24\x02\x00\x00\x6a\x00\x68";

	//ͨSSDTлNtCreateThreadĵַ,ΪӲ
	AddrNtCreateThread = KeServiceDescriptorTable.ServiceTableBase[INDEX_OF_NTCREATETHREAD];	
	DbgPrint("[ProcessMon]AddrNtCreateThread = 0x%.8X\r\n",AddrNtCreateThread);

	//ȴNtCreateThreadлPspCreateThreadĵַ,
	for (i=0;
		 i<0x1000;
		 i++){
		if (memcmp((PVOID)(AddrNtCreateThread+i),code1,29) == 0){
			AddrPspCreateThread = AddrNtCreateThread + i + 29;
			AddrPspCreateThread = AddrPspCreateThread + 4 + *(PULONG)AddrPspCreateThread;
			DbgPrint("[ProcessMon]AddrPspCreateThread = 0x%.8X\r\n",AddrPspCreateThread);
			break;
		}
	}


	//ûҵ
	if (AddrPspCreateThread == 0){
		return NULL;
	}

	//ٴPspCreateThreadлPspUserThreadStartupĵַ,
	for (i=0;
		 i<0x1000;
		 i++){
		 
		 if (memcmp((PVOID)(AddrPspCreateThread+i),code2,15) == 0){
			AddrPspUserThreadStartup = *(PULONG)(AddrPspCreateThread + i + 15);
			DbgPrint("[ProcessMon]AddrPspUserThreadStartup = 0x%.8X\r\n",AddrPspUserThreadStartup);
			break;
		 }
	}

	return (PVOID)AddrPspUserThreadStartup;
}



/************************************************************************/
/*    жPIDڲڱ	                                                */
/*    ڷ1  ڷ0	                                            */
/************************************************************************/
ULONG IsPidInTable(ULONG Pid)
{
	ULONG i;
	for (i=0;
		 i<g_i;
		 i++)
		
		 if (Pid == g_PidTable[i])	
			return 1;
	return 0;
}



/************************************************************************/
/*     ӻɾPIDеı                                        */
/*	   bAddָӻɾ  Ϊ0ɾ  0							*/
/*     0ʧ  1ɹ	                                            */
/************************************************************************/
ULONG SetPidTable(IN ULONG Pid,
				  IN ULONG bAdd)
{
	ULONG i;

	if (bAdd)//ӻɾ
	{
		if (g_i >= MAX_PID_TABLE )//Χ,
		{
			DbgPrint("[ProcessMon]Out of Pid Table!\r\n");
			return 0;
		}
		g_PidTable[g_i++] = Pid;
		return 1;
	}
	else
	{	//ɾ
		for (i = 0; 
			 i < g_i; 
			 i++)

			 if (Pid == g_PidTable[i])
			 {
				//Ѻÿһǰһ
				for ( ;
					 i < g_i-1;
					 i++)
					
					 g_PidTable[i] = g_PidTable[i+1];
				
				g_PidTable[--g_i] = 0;
				return 1;
			 }
		DbgPrint("[ProcessMon]Wrong PID to delete!\r\n");
		return 0;
	}

}




/************************************************************************/
/*   ͨPIDýȫ·,ɹҪRtlFreeAnsiString                  */
/************************************************************************/
ULONG GetProcessPathNameByPID(IN ULONG Pid,
							  OUT PANSI_STRING pas)
{
	NTSTATUS status = STATUS_SUCCESS;
	ULONG dwEProcess = 0, dwAddress1 = 0;
	UNICODE_STRING uniProcessName;


	pas->Length = 0;

	status = PsLookupProcessByProcessId((PVOID)Pid, (PEPROCESS*)&dwEProcess); //PIDתEPROCESS

	if (!NT_SUCCESS(status))
	{
		DbgPrint("[ProcessMon]PsLookupProcessByProcessId failed with error 0x%.8X\r\n",status);
		return 0;
	}

	ObDereferenceObject((PEPROCESS)dwEProcess); //PsLookupProcessByProcessIdҪô

	KeAttachProcess((PEPROCESS)dwEProcess);		//ӵָ

	GetProcessPathName(dwEProcess,pas);			//ȡ

	KeDetachProcess();							//

	return 1;
	
}



/************************************************************************/
/*    ýȫ·,                                                 */
/*    ͨEPROCESSҵPEB,ȡеFullName                            */
/*    copyĺ:) 	                                                    */
/************************************************************************/
void GetProcessPathName(IN ULONG dwEPROCESS,
						OUT PANSI_STRING pas) 
{ 
	ULONG dwAddress = dwEPROCESS; 
	ULONG dwAddress1;
	UNICODE_STRING uniProcessName;

	pas->Length = 0;
	if(dwAddress == 0 || dwAddress == 0xFFFFFFFF)	return; 
	dwAddress += 0x1B0; 
	if((dwAddress = *(ULONG*)dwAddress) == 0)		return; 
	dwAddress += 0x10; 
	if((dwAddress = *(ULONG*)dwAddress) == 0)		return; 
	dwAddress1 = dwAddress;//2000
	dwAddress += 0x3C; 
	if((dwAddress = *(ULONG*)dwAddress) == 0)		return; 
	if (dwAddress < dwAddress1) dwAddress = dwAddress+dwAddress1;
	RtlInitUnicodeString(&uniProcessName, (PCWSTR)dwAddress); 
	RtlUnicodeStringToAnsiString(pas,&uniProcessName,1);
	return;

} 	



/************************************************************************/
/*    ȡϢ,ûѡ̻                     */
/*    arg[0]  arg[1] ֱΪPspUserThreadStartup 			*/
/*    arg[0] = StartRoutine, arg[1] = StartContext                      */
/************************************************************************/
void DoSomethingIWant(PULONG arg)
{
	ULONG dwEProcess = (ULONG)PsGetCurrentProcess();
	ANSI_STRING ansiCurrentProcessName,ansiPerentProcessName;
	ULONG uRet = 0;
	ULONG Pid, PerentPid;
	KSPIN_LOCK    SpinLock;
	KIRQL kirql;

	PLIST_ENTRY head,curr;
	ULONG n;

	
	if (g_uStartSign == 0)	//û׼?
	{
		return;
	}

	Pid =  (ULONG)PsGetCurrentProcessId();

	PerentPid = *(PULONG)(dwEProcess + OFFSET_PERENT_PID_EPROCESS);//ͨƫƴEPROCESSлȡID,ƫΪӲ

	KeInitializeSpinLock(&SpinLock);

	if (g_uStartSign != arg[1])		//ǷΪ̵ĵһ߳
	{
		//PIDPidTable
		KeAcquireSpinLock(&SpinLock,&kirql);	
		SetPidTable(Pid, 1);
		KeReleaseSpinLock(&SpinLock,kirql);

		//ȡǰ
		GetProcessPathName(dwEProcess,&ansiCurrentProcessName);

		//ȡ
		GetProcessPathNameByPID(PerentPid, &ansiPerentProcessName);

		//ӡϢ~~
		DbgPrint("[ProcessMon]Process Creating, Process Name = %s ,PID = %d ,PerentName = %s PID = %d\r\n",
			ansiCurrentProcessName.Buffer,Pid, ansiPerentProcessName.Buffer,PerentPid);

		//ûѡ
		uRet = GetUserChoose(&ansiPerentProcessName,&ansiCurrentProcessName, PerentPid, Pid);


		//PidTableɾPID
		KeAcquireSpinLock(&SpinLock,&kirql);	
		SetPidTable(Pid, 0);
		KeReleaseSpinLock(&SpinLock,kirql);

		//ͷڴ.
		if(ansiCurrentProcessName.Length)	RtlFreeAnsiString(&ansiCurrentProcessName);
		if(ansiPerentProcessName.Length)	RtlFreeAnsiString(&ansiPerentProcessName);	

		//ûѡл߽
		if(uRet)
			ZwTerminateProcess(NtCurrentProcess(), 0);

		KeSetEvent(&g_eventNotify, 0, 0);	//֪ͨЩȴ߳---------------------
		KeClearEvent(&g_eventNotify);		//Ϊź----------------------------
	}								//													
	else							//													
	{								//												
		//ǵһ߳																				
		while (IsPidInTable(Pid))	//߳ڵȴûж,ȴ					
		{							//														
			KeWaitForSingleObject(&g_eventNotify,Executive,KernelMode,0,0);	// <-----
		}

		//ͨEPROCESS->ThreadListHead߳,ThreadListHeadƫΪӲ
		for (n = 0, curr = head = (PLIST_ENTRY)(dwEProcess + OFFSET_THREAD_LIST_HEAD_EPROCESS);
			 curr->Blink != head ;
			 curr = curr->Blink, n++){} //㵱ǰ̵߳Ŀ

		DbgPrint("[ProcessMon]Pid: %.4d  ,Thread count = %d\r\n",Pid, n);
	}

	
	return;

}



/************************************************************************/
/*    ϢݸӦò㲢ûѡ                                */
/*	  1ǰ  0̴								*/
/************************************************************************/
ULONG GetUserChoose(IN PANSI_STRING pAnsiPerent ,
					IN PANSI_STRING pAnsiCurrent,
					IN ULONG PerentId,
					IN ULONG CurrentPId)
{
	ULONG uRet = 0;

	KeWaitForSingleObject(&g_event,Executive,KernelMode,0,0);	//ͬ,ֻ׼һ
//	_asm int 3;

	if (!MmIsAddressValid((PVOID)g_MsgBuffer))	//Ϊ...
	{
		KeSetEvent(&g_event,0,0);
		return 0;
	}

	memset(g_MsgBuffer, 0, BUFF_LENGTH);	//0

	memcpy(g_MsgBuffer, pAnsiPerent->Buffer, pAnsiPerent->Length);				//
	memcpy(g_MsgBuffer + MAX_PATH, pAnsiCurrent->Buffer, pAnsiCurrent->Length); //ǰ

	*(PULONG)(g_MsgBuffer+2*MAX_PATH) = PerentId;								//ID
	*(PULONG)(g_MsgBuffer+2*MAX_PATH+4) = CurrentPId;							//ǰID

	KeSetEvent(g_pEventWaitInApp,0,0);											//֪ͨû
	KeWaitForSingleObject(g_pEventWaitInDriver,Executive,KernelMode,0,0);		//ȴû

	uRet = *(PULONG)(g_MsgBuffer+2*MAX_PATH+8);									//õûѡ

	KeSetEvent(&g_event,0,0);													//,һ
	return uRet;
}



/************************************************************************/
/*   Լðĺ     ֳCALL DoSomethingIWant                 */
/************************************************************************/
__declspec(naked) void FakePspUserThreadStartup()
{
	__asm{
		pushfd
		pushad
		mov		ebx,esp
		add		ebx,44
		push	ebx
		call	DoSomethingIWant
		popad
		popfd
		jmp		g_Orig
	}
	
}



/************************************************************************/
/*   ȡҹ                                                           */
/*   ҹĵַPspUserThreadStartup+2                                 */
/************************************************************************/
void UnhookPspUserThreadStartup()
{
	PUCHAR pHookAddr = (PUCHAR)FindPspUserThreadStartupAddress();
	LARGE_INTEGER li;	
	li.QuadPart=-20000;



	if (!pHookAddr) return;

	if (!g_Orig)	return;

	pHookAddr += 2;


	__asm{
			cli
			mov  eax,cr0
			and  eax,not 10000h
			mov  cr0,eax
	}
	
	memcpy((PVOID)pHookAddr,g_Orig,5);
	
	__asm{
			mov  eax,cr0
			or   eax,10000h
			mov  cr0,eax
			sti
	}


	while (g_i!=0)	//̶֤߳˳˲ж
	{
		KeDelayExecutionThread(KernelMode,0,&li);
	}
	KeDelayExecutionThread(KernelMode,0,&li);

	
	ExFreePool(g_Orig);
	
}



/************************************************************************/
/*   ҹPspUserThreadStartup									        */
/*   ҹĵַPspUserThreadStartup+2                                 */
/************************************************************************/
void HookPspUserThreadStartup()
{	
	PUCHAR pHookAddr = (PUCHAR)FindPspUserThreadStartupAddress();
	UCHAR JMPCode[5] = {0xe9,0,0,0,0};
	UCHAR JMPBackCode[5] = {0xe9,0,0,0,0};

	g_Orig = ExAllocatePool(NonPagedPool,10);
	if (!g_Orig)
	{
		DbgPrint("[ProcessMon]Failed with Allocate Pool\r\n");
		return ;
	}
	

	if (!pHookAddr) return;

	pHookAddr += 2; //ҹĵַPspUserThreadStartup+2


	*((PULONG)(JMPCode+1)) = (ULONG) FakePspUserThreadStartup - ((ULONG)pHookAddr + 5);

	*((PULONG)(JMPBackCode+1)) = (ULONG)pHookAddr + 5 - ((ULONG)g_Orig + 10);

	memcpy(
			g_Orig,
			(PVOID)pHookAddr,
			5);

	memcpy(
			(PVOID)((ULONG)g_Orig+5),
			(PVOID)JMPBackCode,
			5);

	__asm{
			cli
			mov  eax,cr0
			and  eax,not 10000h
			mov  cr0,eax
	}
	
	memcpy((PVOID)pHookAddr,JMPCode,5);
	
	__asm{
			mov  eax,cr0
			or   eax,10000h
			mov  cr0,eax
			sti
		}


}



NTSTATUS DispatchCreate(PDEVICE_OBJECT pDevObj, PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;

	HookPspUserThreadStartup();
	
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = 0;
	IoCompleteRequest(pIrp, IO_NO_INCREMENT);
	
	return status;
}


NTSTATUS DispatchClose(PDEVICE_OBJECT pDevObj, PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;
	
	if (g_MsgBuffer)
	{
		MmUnmapIoSpace(g_MsgBuffer,BUFF_LENGTH); 
	}
	if (g_pEventWaitInApp)
	{
		ObDereferenceObject(g_pEventWaitInApp);   
	}
	if (g_pEventWaitInDriver)
	{
		ObDereferenceObject(g_pEventWaitInDriver);   
	}

	UnhookPspUserThreadStartup();
	
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = 0;
	IoCompleteRequest(pIrp, IO_NO_INCREMENT);
	
	return status;
}


NTSTATUS DispatchIoctl(PDEVICE_OBJECT pDevObj, PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;
	PIO_STACK_LOCATION IrpStack;
	PVOID InputBuffer;
	PVOID OutputBuffer;
	ULONG InputBufferLength;
	ULONG OutputBufferLength;
	ULONG IoControlCode;

	OBJECT_HANDLE_INFORMATION objInfo;

	ULONG startAddr,endAddr;

	
	status = pIrp->IoStatus.Status = STATUS_SUCCESS;
	pIrp->IoStatus.Information = 0;
	
	IrpStack = IoGetCurrentIrpStackLocation( pIrp );
	
	InputBuffer = IrpStack->Parameters.DeviceIoControl.Type3InputBuffer;
	InputBufferLength = IrpStack->Parameters.DeviceIoControl.InputBufferLength;
	OutputBuffer = pIrp->UserBuffer;
	OutputBufferLength = IrpStack->Parameters.DeviceIoControl.OutputBufferLength;
	IoControlCode = IrpStack->Parameters.DeviceIoControl.IoControlCode;
	
	switch( IoControlCode )
	{
	//*************************************************
	//Ӧò㴫event HANDLEõṹָ
	case IOCTL_SET_EVENT:
		status = ObReferenceObjectByHandle(*(PHANDLE)InputBuffer,   
											EVENT_ALL_ACCESS,   
											*ExEventObjectType,   
											KernelMode,   
											&g_pEventWaitInApp,   
											&objInfo);   
		if (!NT_SUCCESS(status))	break;

		status = ObReferenceObjectByHandle(*(PHANDLE)((ULONG)InputBuffer+4),   
											EVENT_ALL_ACCESS,   
											*ExEventObjectType,   
											KernelMode,   
											&g_pEventWaitInDriver,   
											&objInfo);  

		break;


	//*************************************************
	//ӳڴ
	case IOCTL_SET_BUFFER:
		g_MsgBuffer=(char*)MmMapIoSpace(MmGetPhysicalAddress((void*)(*(PULONG)InputBuffer)),BUFF_LENGTH,0);
		
		break;


	//*************************************************
	//ȡǵһ̵߳StartAddress,ƫΪӲ
	case IOCTL_SET_THREAD_SIGN:
		g_uStartSign = *(PULONG)((ULONG)KeGetCurrentThread() + OFFSET_START_ADDRESS_ETHREAD);
		DbgPrint("[ProcessMon]g_uStartSign = 0x%.8X\r\n",g_uStartSign);
		break;


	}
	pIrp->IoStatus.Status = status;
	pIrp->IoStatus.Information = 0;
	IoCompleteRequest(pIrp, IO_NO_INCREMENT);
	
	return status;
	
}


void OnUnload(PDRIVER_OBJECT pdo)
{
	UNICODE_STRING	usLinkName;

	DbgPrint("[ProcessMon]OnUnload is Calling\r\n");

	RtlInitUnicodeString( &usLinkName, LINK_NAME );

	IoDeleteSymbolicLink( &usLinkName );

	IoDeleteDevice( pdo->DeviceObject );

	DbgPrint("[ProcessMon]OnUnload Called\r\n");

}



/************************************************************************/
/*   ں                                                           */
/************************************************************************/
NTSTATUS DriverEntry(PDRIVER_OBJECT pdo ,PUNICODE_STRING punicode)
{
	NTSTATUS status = STATUS_SUCCESS;
	UNICODE_STRING usDeviceName;
	PDEVICE_OBJECT pDeviceObject;
	UNICODE_STRING usLinkName;
	
	
	DbgPrint("[ProcessMon]DriverEntry is Calling\r\n");
	pdo->MajorFunction[IRP_MJ_CREATE] = DispatchCreate;
	pdo->MajorFunction[IRP_MJ_CLOSE] = DispatchClose;
	pdo->MajorFunction[IRP_MJ_DEVICE_CONTROL] = DispatchIoctl;
	pdo->DriverUnload = OnUnload;
	
	
	RtlInitUnicodeString(&usDeviceName,DEVICE_NAME);

	status = IoCreateDevice(
		pdo,
		0,
		&usDeviceName,
		FILE_DEVICE_DRVFLTIP,
		0,
		FALSE,
		&pDeviceObject);

	if(!NT_SUCCESS(status))
	{
		DbgPrint("豸ʧ\r\n");
		return status;
	}


	RtlInitUnicodeString(&usLinkName,LINK_NAME);

	status = IoCreateSymbolicLink(&usLinkName, &usDeviceName);

	if(!NT_SUCCESS(status))
	{
		DbgPrint("ʧ\r\n");
		IoDeleteDevice(pDeviceObject);
		return status;
	}

	//ʼ
	KeInitializeEvent(&g_eventNotify,NotificationEvent,0);
	KeInitializeEvent(&g_event,SynchronizationEvent,1);
	g_Orig = NULL;
	g_pEventWaitInApp = NULL;
	g_pEventWaitInDriver = NULL;
	g_MsgBuffer = NULL;
	memset(g_PidTable, 0, MAX_PID_TABLE*sizeof(ULONG));
	g_uStartSign = 0;

	return STATUS_SUCCESS;
}